package org.nuiton.topia.security.entities.authorization;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaSecurityDAOHelper.TopiaSecurityEntityEnum;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class TopiaAssociationAuthorizationDAOAbstract<E extends TopiaAssociationAuthorization> extends TopiaAuthorizationDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)TopiaAssociationAuthorization.class;
    }

    @Override
    public TopiaSecurityEntityEnum getTopiaEntityEnum() {
        return TopiaSecurityEntityEnum.TopiaAssociationAuthorization;
    }

    public E findByIdBeginAssociation(String v) throws TopiaException {
        E result = findByProperty(TopiaAssociationAuthorization.ID_BEGIN_ASSOCIATION, v);
        return result;
    }

    public List<E> findAllByIdBeginAssociation(String v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaAssociationAuthorization.ID_BEGIN_ASSOCIATION, v);
        return result;
    }

    public E findByNameAssociation(String v) throws TopiaException {
        E result = findByProperty(TopiaAssociationAuthorization.NAME_ASSOCIATION, v);
        return result;
    }

    public List<E> findAllByNameAssociation(String v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaAssociationAuthorization.NAME_ASSOCIATION, v);
        return result;
    }

    public E findByActions(int v) throws TopiaException {
        E result = findByProperty(TopiaAssociationAuthorization.ACTIONS, v);
        return result;
    }

    public List<E> findAllByActions(int v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaAssociationAuthorization.ACTIONS, v);
        return result;
    }

    public E findByPrincipals(Set v) throws TopiaException {
        E result = findByProperty(TopiaAssociationAuthorization.PRINCIPALS, v);
        return result;
    }

    public List<E> findAllByPrincipals(Set v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaAssociationAuthorization.PRINCIPALS, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //TopiaAssociationAuthorizationDAOAbstract<E extends TopiaAssociationAuthorization>
