package org.nuiton.topia.taas.entities;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaSecurityDAOHelper.TopiaSecurityEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class TaasUserDAOAbstract<E extends TaasUser> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)TaasUser.class;
    }

    @Override
    public TopiaSecurityEntityEnum getTopiaEntityEnum() {
        return TopiaSecurityEntityEnum.TaasUser;
    }

    public E findByLogin(String v) throws TopiaException {
        E result = findByProperty(TaasUser.LOGIN, v);
        return result;
    }

    public List<E> findAllByLogin(String v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.LOGIN, v);
        return result;
    }

    public E findByPassword(String v) throws TopiaException {
        E result = findByProperty(TaasUser.PASSWORD, v);
        return result;
    }

    public List<E> findAllByPassword(String v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.PASSWORD, v);
        return result;
    }

    public E findByEmail(String v) throws TopiaException {
        E result = findByProperty(TaasUser.EMAIL, v);
        return result;
    }

    public List<E> findAllByEmail(String v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.EMAIL, v);
        return result;
    }

    public E findByEnabled(boolean v) throws TopiaException {
        E result = findByProperty(TaasUser.ENABLED, v);
        return result;
    }

    public List<E> findAllByEnabled(boolean v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.ENABLED, v);
        return result;
    }

    public E findByLastConnectionDate(Date v) throws TopiaException {
        E result = findByProperty(TaasUser.LAST_CONNECTION_DATE, v);
        return result;
    }

    public List<E> findAllByLastConnectionDate(Date v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.LAST_CONNECTION_DATE, v);
        return result;
    }

    public E findByNumberOfConnection(int v) throws TopiaException {
        E result = findByProperty(TaasUser.NUMBER_OF_CONNECTION, v);
        return result;
    }

    public List<E> findAllByNumberOfConnection(int v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.NUMBER_OF_CONNECTION, v);
        return result;
    }

    public E findByLink(String v) throws TopiaException {
        E result = findByProperty(TaasUser.LINK, v);
        return result;
    }

    public List<E> findAllByLink(String v) throws TopiaException {
        List<E> result = findAllByProperty(TaasUser.LINK, v);
        return result;
    }

    public E findContainsPrincipals(TaasPrincipal v) throws TopiaException {
        E result = findContains(TaasUser.PRINCIPALS, v);
        return result;
    }

    public List<E> findAllContainsPrincipals(TaasPrincipal v) throws TopiaException {
        List<E> result = findAllContains(TaasUser.PRINCIPALS, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //TaasUserDAOAbstract<E extends TaasUser>
